<template>
  <j-modal
    :title="title"
    :width="width"
    :visible="visible"
    :confirmLoading="confirmLoading"
    switchFullscreen
    @ok="handleOk"
    @cancel="handleCancel"
    cancelText="关闭">
    <a-spin :spinning="confirmLoading">
      <a-form :form="form">

        <a-form-item label="税务信息" :labelCol="labelCol" :wrapperCol="wrapperCol">
          <a-input-number v-decorator="['taxId', validatorRules.taxId]" placeholder="请输入税务信息" style="width: 100%"/>
        </a-form-item>
        <a-form-item label="开始区间" :labelCol="labelCol" :wrapperCol="wrapperCol">
          <a-input-number v-decorator="['startInterval', validatorRules.startInterval]" placeholder="请输入开始区间" style="width: 100%"/>
        </a-form-item>
        <a-form-item label="结束区间" :labelCol="labelCol" :wrapperCol="wrapperCol">
          <a-input-number v-decorator="['endInterval']" placeholder="请输入结束区间" style="width: 100%"/>
        </a-form-item>
        <a-form-item label="税率（例如0.06）" :labelCol="labelCol" :wrapperCol="wrapperCol">
          <a-input-number v-decorator="['rate', validatorRules.rate]" placeholder="请输入税率（例如0.06）" style="width: 100%"/>
        </a-form-item>
        <a-form-item label="速算值" :labelCol="labelCol" :wrapperCol="wrapperCol">
          <a-input-number v-decorator="['calculationValue', validatorRules.calculationValue]" placeholder="请输入速算值" style="width: 100%"/>
        </a-form-item>

      </a-form>
    </a-spin>
  </j-modal>
</template>

<script>

  import { httpAction } from '@/api/manage'
  import pick from 'lodash.pick'
  import { validateDuplicateValue } from '@/utils/util'


  export default {
    name: "HlwTaxRateModal",
    components: { 
    },
    data () {
      return {
        form: this.$form.createForm(this),
        title:"操作",
        width:800,
        visible: false,
        model: {},
        labelCol: {
          xs: { span: 24 },
          sm: { span: 5 },
        },
        wrapperCol: {
          xs: { span: 24 },
          sm: { span: 16 },
        },
        confirmLoading: false,
        validatorRules: {
          taxId: {
            rules: [
              { required: true, message: '请输入税务信息!'},
            ]
          },
          startInterval: {
            rules: [
              { required: true, message: '请输入开始区间!'},
            ]
          },
          rate: {
            rules: [
              { required: true, message: '请输入税率（例如0.06）!'},
            ]
          },
          calculationValue: {
            rules: [
              { required: true, message: '请输入速算值!'},
            ]
          },
        },
        url: {
          add: "/hlwtax/hlwTaxRate/add",
          edit: "/hlwtax/hlwTaxRate/edit",
        }
      }
    },
    created () {
    },
    methods: {
      add () {
        this.edit({});
      },
      edit (record) {
        this.form.resetFields();
        this.model = Object.assign({}, record);
        this.visible = true;
        this.$nextTick(() => {
          this.form.setFieldsValue(pick(this.model,'taxId','startInterval','endInterval','rate','calculationValue'))
        })
      },
      close () {
        this.$emit('close');
        this.visible = false;
      },
      handleOk () {
        const that = this;
        // 触发表单验证
        this.form.validateFields((err, values) => {
          if (!err) {
            that.confirmLoading = true;
            let httpurl = '';
            let method = '';
            if(!this.model.id){
              httpurl+=this.url.add;
              method = 'post';
            }else{
              httpurl+=this.url.edit;
               method = 'put';
            }
            let formData = Object.assign(this.model, values);
            console.log("表单提交数据",formData)
            httpAction(httpurl,formData,method).then((res)=>{
              if(res.success){
                that.$message.success(res.message);
                that.$emit('ok');
              }else{
                that.$message.warning(res.message);
              }
            }).finally(() => {
              that.confirmLoading = false;
              that.close();
            })
          }
         
        })
      },
      handleCancel () {
        this.close()
      },
      popupCallback(row){
        this.form.setFieldsValue(pick(row,'taxId','startInterval','endInterval','rate','calculationValue'))
      },

      
    }
  }
</script>